import '../field/dfbasefield.dart';
import 'dfqueryentityjoin.dart';
import 'dfquerycriteriagroup.dart';
import 'dfqueryorderby.dart';
import 'dfquerypaging.dart';
import 'package:meta/meta.dart';

enum DfQueryPurpose {
  FETCH,
  ADD,
  UPDATE_WHOLE_ENTITY_ATTRS,
  UPDATE_SOME_RNTITY_ATTRS,
  DELETE
}

class DfQuery {
  Map<DfBaseField, dynamic> fields;
  DfQueryEntityJoin entityJoin;
  DfQueryCriteriaGroup criteriaGroup;
  List<DfQueryOrderBy> orderBy;
  List<DfBaseField> groupBy;
  Paging paging;
  DfQueryPurpose purpose;

  DfQuery({@required this.purpose, @required dynamic queryFields, @required this.entityJoin, this.criteriaGroup, this.orderBy, this.groupBy, this.paging}) {
    if (queryFields is Map) {
      fields = queryFields;  
    }
    else {
      fields = Map<DfBaseField, dynamic>();
      List<DfBaseField> arrFields = queryFields;
      arrFields.forEach((field) => fields[field] = null);
    }
  }
}

