import 'package:meta/meta.dart';
import '../entity/dfbaseentity.dart';

abstract class DfBaseField {

  DfBaseEntity entity;
  String name;
  bool displayOnly = false;
  var value;

  DfBaseField({@required this.entity, @required this.name, this.displayOnly, this.value});

  setValueFromQueryResult(Map<String,dynamic> dict);

  @override
  bool operator ==(Object other) => other is DfBaseField && other.name == name && other.entity.name == entity.name;

  @override
  int get hashCode => name.hashCode + entity.name.hashCode;  

}