import 'package:ingdao/dataflow/control/dfquery.dart';
import 'package:ingdao/dataflow/entity/dfbaseentity.dart';
import 'package:ingdao/dataflow/entity/dfwebentity.dart';
import 'package:ingdao/dataflow/field/dfbasefield.dart';
import 'package:ingdao/dataflow/field/dfwebfield.dart';
import 'rolefield.dart';

class RoleWeb extends DfWebEntity with RoleField {
  RoleWeb ({String id, String name}) : super(contextPath: "role") {
    fId = DfWebField(entity: this, name: "id", value: id);
    fName = DfWebField(entity: this, name: "name", value: name);
  }

  //Define what are the fields will map back the result from http response Map<String,dynamic>
  @override
  List<DfWebField> fields() {
     return [fId,fName];
  }

  @override
  DfWebReqParam convertToWebReqParam(DfQuery query) {
    return null;
  }

  @override
  DfBaseEntity<DfBaseField> newInstance() {
    return RoleWeb();
  }
}